local utils = require("utils")

local function ImproveGlacier(inst)
	local oldonwork = inst.components.workable.onwork
	inst.components.workable.onwork = function(inst, worker, workleft)
		--Allow ice to spawn while mining
		utils.DropLootRandom(inst, "ice", .1)
		oldonwork(inst, worker, workleft)
	end
end

return ImproveGlacier